
import os
import tempfile

try:
    import zLOG

except:
    class foo:
        pass

    def LOG( subsystem, severity, short ):
        if severity > -500:
            print subsystem, severity, short

    zLOG = foo()
    zLOG.LOG = LOG
    zLOG.BLATHER = 0
    zLOG.INFO = 1

class ShellCommandProcessor:

    active = 0
    usepassfile = 0

    def processStreams(self, command):

        if not self.active:
            if self._v_debug:
                zLOG.LOG('ZCVSMixin', zLOG.BLATHER,
                         "Not processing streams... self.active = 0")
                
            return  0, '', '' # no commands are executed unless this is true....
        
        #
        # Zope doesn't like forking... so let's just be dumb and use files
        # rather than pipes..
        #
        
        stdoutFname = tempfile.mktemp()
        stderrFname = tempfile.mktemp()

        iresult = self.doCommand( command, stdoutFname, stderrFname )
        
        zLOG.LOG('ZCVSMixin', zLOG.BLATHER, 'checking result .. "%i"' % iresult)

        resultStd = open(stdoutFname).read()
        resultErr = open(stderrFname).read()

        os.remove(stdoutFname)
        os.remove(stderrFname)

        zLOG.LOG('ZCVSMixin', zLOG.BLATHER, 'Got result.. "%s"' % resultStd)
        zLOG.LOG('ZCVSMixin', zLOG.BLATHER, 'Got err result.. "%s"' % resultErr)

        return iresult, resultStd, resultErr

    def doCommandUnix(self, command, stdoutFname, stderrFname):

        cmd = 'sh -v -c "%s" >%s 2>%s' % (command, stdoutFname, stderrFname)

        if self.usepassfile:
            os.environ['CVS_PASSFILE'] = self.passfile

        iresult = os.system(cmd)
        return iresult

    def doCommandWin(self, command, stdoutFname, stderrFname):

        cmd = '"%s" >%s 2>%s' % (command, stdoutFname, stderrFname)

        iresult = os.system(cmd)
        return iresult

    def processCommand( self, command ):
        """
        Run a cvs command as a pipe..
        """

        resultVal, resultStd, resultErr = self.processStreams( command )

        return self.formatResult( command, resultVal, resultStd, resultErr)

try:
    import posix
    ShellCommandProcessor.doCommand = ShellCommandProcessor.doCommandUnix
except:
    ShellCommandProcessor.doCommand = ShellCommandProcessor.doCommandWin

if __name__=='__main__':
    x = ShellCommandProcessor()
    x.active = 1

    print x.processStreams('ls -lga')
